/*
 * jQuery Flicker Plugin
 * version: 1.00 (12-11-2009)
 * @requires jQuery v1.2.6 or later
 * @Developer June http://starplatina.tistory.com
 *
 * Dual licensed under the MIT and GPL licenses:
 *   http://www.opensource.org/licenses/mit-license.php
 *   http://www.gnu.org/licenses/gpl.html
 *
 */
;(function($) {
	$.fn.favoriteFlicker = function( options){

		var defaults={
			method : 	'',
			api_key : 	'',
			format : 	'',
			text :		'',
			perpage : 12,
			imgSize : 't'
		};
		var options = $.extend(defaults, options);

		var url = "http://api.flickr.com/services/rest/?method=" +
			options.method+"&format=" + options.format + "&api_key=" + options.api_key + "&text=" + options.text +"&per_page=" + options.perpage,
			target = $( this);

		function setDiv() {
			target.empty();
			target.append( '<div class="flickrThumbnail">'
				+ '<div class="flickrResultImgs"></div>' + '<div class="flickNavi" align="center"></div></div>');
			target.append( '<div class="flickrDetail"></div>');
		};

		function getImgUrl( farm, server, id, secret, type) {
			var url = "http://farm"+farm+".static.flickr.com/"+server+"/"+id+"_"+secret;
			if ( type == 'default')
				return url + ".jpg";
			else
				return url +"_" + options.imgSize + ".jpg";

		};

		function makeNavigation( data) {
			var paging = makePaging( data.page, data.pages),
				flickNavi = $( '.flickNavi');
			flickNavi.append( "<span class='flickerMoveFirst'>처음</span> | <span class='flickerBtnPrev'>이전</span>");
			$.each(paging, function(){
				if ( this == data.page ) {
					flickNavi.append( "<span class='flickrMovePageTo' style='color: red;'> "+this+" </span>");
				} else
					flickNavi.append( "<span class='flickrMovePageTo'> "+this+" </span>");
			});
			flickNavi.append( "<span class='flickerBtnNext'>다음</span> | <span class='flickerMoveLast'>마지막</span><div align='right'>"+
				data.page + "/ " + data.pages + " total : " + data.total + "</div>");

			$( '.flickerMoveFirst').click( function(){
				movePage( 'first', 1);
			});
			$( '.flickerMoveLast').click( function(){
				movePage( 'last', data.pages);
			});
			$( '.flickrMovePageTo').click( function(){
				movePage( 'default',  $( this).text());
			});
			$( '.flickerBtnNext').click( function(){
				movePage( 'next', data.page);
			});
			$( '.flickerBtnPrev').click( function(){
				movePage( 'prev', data.page);
			});
		};

		function makePaging( page, total) {
			var paging = new Array();
			if ( page <= 5) {
				for ( var i = 0, end = total; i < end; i++) {
					if ( i >= 10) break;
						paging.push( i + 1);
				}
			} else {
				for ( var i = page - 5, j = 0; i < page + 6; i++, j++) {
					if ( i >= total) break;
						paging.push( i + 1);
				}
			}
			return paging;
		};

		function movePage( type, page) {
			$( '.flickrDetail').empty();
			switch( type) {
				case 'next' :
					getList( ++page);
					break;
				case 'prev' :
					getList( --page);
					break;
				case 'first' :
					getList( 1);
					break;
				case 'last' :
					getList( page);
					break;
				default :
					getList( page);
					break;
			}
		};

		function getList( page) {
			refresh();
			$( '.flickrThumbnail').addClass( 'flickrIndicator');
			$.ajax({
				url : url+"&page="+page,
				type : 'get',
				dataType : 'jsonp',
				jsonp : 'jsoncallback',
				success : function(data) {
		          	$.each(data.photos.photo, function( index, val){
						var imgUrl = getImgUrl(val.farm, val.server, val.id, val.secret, null),
							nextImgUrl = getImgUrl(val.farm, val.server, val.id, val.secret, 'default');
						target.find( '.flickrResultImgs').append( "<a rel='group' title='"+nextImgUrl+"' href='#'>"+
								"<img src='"+imgUrl+"' class='flickrImg' width='100' height='65'></a>");

					});
		          	makeNavigation( data.photos);
		          	$( 'a').click( function(){
		          		$( this).find( 'img').addClass( 'flickrImgSelected');
		          		$( '.flickrDetail').empty();
						imgurl = $( this).attr( 'title');
						img = new Image();
						img.src = imgurl;
						$( '.flickrDetail').append( img);
					}).mousedown( function(){
		          		$( '.flickrImgSelected').removeClass( 'flickrImgSelected');
					});
				},
				complete : function() {
		          	$( '.flickrThumbnail').removeClass( 'flickrIndicator');
				}
			});
		};

		function refresh() {
			$( '.flickrResultImgs').empty();
			$( '.flickNavi').empty();
		};
		setDiv();
		getList( 1);
	};

})(jQuery);
